
#declare r = seed(0);
//Functions for foreground HF
#declare F1 = function { pattern { granite translate <rand(r),rand(r),rand(r)> rotate <rand(r),rand(r),rand(r)>} }
#declare F2 = function { pattern { leopard turbulence 0.4 scale 0.10 translate <rand(r),rand(r),rand(r)> rotate <rand(r),rand(r),rand(r)> } }
#declare F3 = function { pattern { leopard turbulence 0.3 scale 0.15 translate <rand(r),rand(r),rand(r)> rotate <rand(r),rand(r),rand(r)>} }
#declare Curve1 = function { exp(-30*(x-0.5)*(x-0.5))*exp(-20*(y-0.5)*(y-0.5)) }
#declare Curve2 = function { exp(-50*(x-0.5)*(x-0.5))*exp(-40*(y-0.5)*(y-0.5)) }
#declare Curve3 = function { exp(-50*(x-0.5)*(x-0.5))*exp(-5*(y-0.5)*(y-0.5)) }                                                                              

//Foreground
#declare Foreground = height_field { 
  function 1024, 1024 { 0.67*Curve1( x-0.1, y-0.27, z) + 0.7*Curve2( x+0.22, y-0.27, z ) + 0.4*Curve3( x+0.45, y-0.3, z ) + 0.01*F1(5*x,5*y,z)*y + 0.02*F2(3*x,3*y,z)*y }
  translate <-0.5, 0, -0.5>
  scale <700, 150, 700>
  translate <0, -1, 0>
  }

#if ( FrontHF = 1 ) 
  difference {
    object { Foreground } 
    box { <-200, -50, 0> <200, -0.2, 400> }
  
  texture { 
    pigment { 
      granite
      turbulence 0.2
      scale 4
      color_map {
        [0.0 rgb 0.8*<0.7, 0.65, 0.6> ]
        [0.5 rgb <0.262, 0.277, 0.324> ]
        [0.7 rgb <0.383, 0.359, 0.359> ]
        [1.0 rgb <0.504, 0.398, 0.332> ]
        }
      } 
    normal { bumps 0.3 scale 0.01 }
    #if ( Radious = 1 ) finish { ambient 0 } #end
    } 
  texture {
    pigment {
      granite
      scale 9
      color_map {
        [ 0.0 rgbt 1 ]
        [ 0.5 rgbt 1 ]
        [ 1.0 rgbt 0.8*<0.6, 0.4, 0.3, 0> ]
        }
      }
    #if ( Radious = 1 ) finish { ambient 0 } #end
    }
  //Draw contour lines
  #if ( LandContour = 1)
  texture {
    pigment { 
      gradient y
      color_map {
        [0.0 rgbt 1]
        [0.48 rgbt 1]
        [0.48 rgbt 0]
        [0.52 rgbt 0]
        [0.52 rgbt 1]
        [1.0 rgbt 1]
        }
      scale 2
      }
    #if ( Radious = 1 ) finish { ambient 0 } #end
    }
  #end 

  }
#end


//Background HF
#declare r = seed(0);
#declare F4 = function { pattern { granite translate <rand(r),rand(r),rand(r)> rotate <rand(r),rand(r),rand(r)>} }
#declare F5 = function { pattern { leopard turbulence 0.4 scale 0.10 translate <rand(r),rand(r),rand(r)> rotate <rand(r),rand(r),rand(r)> } }
#declare F6 = function { pattern { leopard turbulence 0.6 scale 0.15 translate <rand(r),rand(r),rand(r)> rotate <rand(r),rand(r),rand(r)>} }
#declare Curve4 = function { exp(-1*(x-0.5)*(x-0.5))*exp(-10*(y-0.5)*(y-0.5)) }
#declare Curve5 = function { exp(-50*(x-0.5)*(x-0.5))*exp(-20*(y-0.5)*(y-0.5)) }
            
#declare Background = height_field { 
  function 512, 512 { 0.6*Curve4(x+0.2,y+0.25,z) + 0.5*Curve5(x,y-0.1,z) + 0.4*Curve5(x-0.3,y+0.05,z) + 0.5*Curve5(x+0.35,y-0.05,z)
  + 0.05*F4(x,y,z) + 0.25*F5(x,y,z)*(1-y) + 0.25*F6(x,y,z)*(1-y) }
  translate <-0.5, 0, -0.5>
  scale <1800, 155, 1000>
  translate <0, -10, 750>
  }

#if ( BackHF = 1 ) 
  difference {
    object { Background } 
    box { <-200, -50, 0> <200, -0.2, 400> }
  
  texture { 
    pigment { 
      granite
      turbulence 0.2
      scale 4
      color_map {
        [0.0 rgb 0.8*<0.7, 0.65, 0.6> ]
        [0.5 rgb <0.262, 0.277, 0.324> ]
        [0.7 rgb <0.383, 0.359, 0.359> ]
        [1.0 rgb <0.504, 0.398, 0.332> ]
        }
      } 
    normal { bumps 0.3 scale 0.01 }
    #if ( Radious = 1 ) finish { ambient 0 } #end
    } 
  texture {
    pigment {
      granite
      scale 9
      color_map {
        [ 0.0 rgbt 1 ]
        [ 0.5 rgbt 1 ]
        [ 1.0 rgbt 0.8*<0.6, 0.4, 0.3, 0> ]
        }
      }
    #if ( Radious = 1 ) finish { ambient 0 } #end
    }
 /* texture {
    pigment { 
      bozo
      turbulence 0.5
      scale 100
      color_map {
        [ 0.0 rgbt <0.495, 0.577, 0.207, 0.000> ]
        [ 0.2 rgbt <0.495, 0.577, 0.207, 0.000> ]
        [ 0.7 rgbt <1.000, 1.000, 1.000, 1.000> ]
        [ 1.0 rgbt <1.000, 1.000, 1.000, 1.000> ]
        }
      }
    normal { bumps 1 scale 0.5 }
    #if ( Radious = 1 ) finish { ambient 0 } #end
    
    }   */

  
    }
#end